#include "stdafx.h"
#include "DeviceManage.h"
#include "AjNetSdkDemo.h"
#include "AjNetSdkDemoDlg.h"
#include "NetSDKDevice.h"

CDeviceManage::CDeviceManage()
{
	InitializeCriticalSection(&m_csSearch);
}


CDeviceManage::~CDeviceManage()
{
//	CleanUpSearchMap();
//	CleanUpDeviceMap();
	LeaveCriticalSection(&m_csSearch);
}

int CDeviceManage::InsertDeviceToMap(LONG index)
{
	EnterCriticalSection(&m_csSearch);
	DEV_INFO *pInfo = NULL;
	m_search_Aj_list.Lookup(index, pInfo);
	if (pInfo && pInfo->index == index)
	{
		CDeviceBase* pTempDevice = NULL;
		pTempDevice = GetDeviceByIp(pInfo->ipcInfo.szIP);
		if (pTempDevice)
		{
			LeaveCriticalSection(&m_csSearch);
			return -1;//Ѵ 豸
		}		
		CMapAutoLock lock;
		CDeviceBase* pDevice = new CNetSDKDevice(&(pInfo->ipcInfo));
		if (pDevice)
		{
			m_devMap.SetAt(pInfo->ipcInfo.szIP, pDevice);
			((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->InsertDeviceToTree(pDevice);
			pDevice->LoginDevice();
			pDevice = NULL;
			LeaveCriticalSection(&m_csSearch);
			return 0;
		}
	}
	LeaveCriticalSection(&m_csSearch);
	return -1;
}

int CDeviceManage::InsertDeviceToMapBySearch(DEV_INFO* pInfo)
{
	EnterCriticalSection(&m_csSearch);
	DEV_INFO* pInfoTemp = NULL;
	m_search_Aj_list.Lookup(pInfo->index, pInfoTemp);
	if (pInfoTemp == NULL)
	{
		m_search_Aj_list.SetAt(pInfo->index, pInfo);
		pInfo = NULL;
	}
	LeaveCriticalSection(&m_csSearch);
	return 0;
}
int CDeviceManage::CleanUpSearchMap()
{
	EnterCriticalSection(&m_csSearch);
	DEV_INFO* pInfo = NULL;
	long index = -1;
	POSITION pos = m_search_Aj_list.GetStartPosition();
	while (pos)
	{
		m_search_Aj_list.GetNextAssoc(pos, index, pInfo);
		if (pInfo,pInfo->index == index)
		{
			SAFE_DELETE(pInfo);
		}
	}
	m_search_Aj_list.RemoveAll();
	LeaveCriticalSection(&m_csSearch);
	return 0;
}

int CDeviceManage::CleanUpDeviceMap()
{
	CMapAutoLock lock;
	CDeviceBase* pDevice = NULL;
	CString strIp;
	POSITION pos = m_devMap.GetStartPosition();
	while (pos)
	{
		m_devMap.GetNextAssoc(pos, strIp, pDevice);
		if (pDevice)
		{
			pDevice->LoginDevice();
			SAFE_DELETE(pDevice);
			m_devMap.RemoveKey(strIp);
		}
	}
	return 0;
}

DEV_INFO* CDeviceManage::GetDevInfoByIndex(LONG index)
{
	DEV_INFO* pInfo = NULL;
	if (index >= 0)
	{
		m_search_Aj_list.Lookup(index, pInfo);
	}
	return pInfo;
}

CDeviceBase* CDeviceManage::GetDeviceByIp(CString strIp)
{
	CDeviceBase* pDevice = NULL;
	m_devMap.Lookup(strIp, pDevice);
	if (pDevice && strIp.Compare(pDevice->m_szDevIP) != 0)
	{
		pDevice = NULL;
	}
	return pDevice;
}

CDeviceBase* CDeviceManage::GetDeviceById(LONG lUserId)
{
	CDeviceBase *pDevice = NULL;
	if (lUserId > 0)
	{
		CMapAutoLock lock;
		POSITION pos = m_devMap.GetStartPosition();
		while (pos)
		{
			CDeviceBase *pTemp = NULL;
			CString strKey;
			strKey.Empty();
			m_devMap.GetNextAssoc(pos, strKey, pTemp);
			if (pTemp->m_szProtocol == 0)
			{
				if (lUserId == ((CNetSDKDevice*)pTemp)->m_lUserID)
				{
					pDevice = (CNetSDKDevice*)pTemp;
					break;
				}
			}
		}
	}
	return pDevice;
}

int CDeviceManage::RealPlay(LPCTSTR lpUrl, int iWndIndex, int isSub)
{
	if (iWndIndex >= 0 && iWndIndex <= MAX_CHANNEL)
	{
		CMapAutoLock lock;
		CDeviceBase *pDevice = NULL;
		pDevice = GetDeviceByIp(lpUrl);
		return RealPlay(pDevice, iWndIndex, isSub);
	}
	return -1;
}

int  CDeviceManage::RealPlay(CDeviceBase* pDevice, int iWndIndex, int isSub)
{
	if (pDevice && iWndIndex >= 0 && iWndIndex <= MAX_CHANNEL)
	{
		CDeviceBase *pDeviceDest = NULL;
		pDeviceDest = ((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->GetPlayerWnd(iWndIndex)->GetDevice();
		if (pDeviceDest)
		{
			if (pDeviceDest != pDevice || pDeviceDest->GetPlayStream() != isSub)
				StopRealPlay(pDeviceDest);
		}
		if (isSub != 0 && isSub != 1)
		{
			isSub = 0;
		}
		pDevice->RealPlay(iWndIndex, isSub);
		return 0;
	}
	return -1;
}

int CDeviceManage::StopRealPlay(CDeviceBase* pDevice)
{
	if (pDevice)
		return pDevice->StopRealPlay();
	return -1;
}

int CDeviceManage::StopRealPlay(LPCTSTR lpUrl)
{
	CMapAutoLock lock;
	CDeviceBase *pDevice = NULL;
	pDevice = GetDeviceByIp(lpUrl);
	if (pDevice)
	{
		pDevice->StopRealPlay();
		return 0;
	}
	return -1;
}

int CDeviceManage::StopRealPlay(int iWndIndex)
{
	if (iWndIndex >= 0 && iWndIndex <= MAX_CHANNEL)
	{
		CMapAutoLock lock;
		CDeviceBase* pDevice = NULL;
		pDevice = ((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->GetPlayerWnd(iWndIndex)->GetDevice();
		if (pDevice)
			return StopRealPlay(pDevice);
	}
	return -1;
}

int CDeviceManage::ModifyDeviceNetWork(DEV_INFO *pInfo)
{
	int lRet = -1;
	/*if (pInfo)
	{
		CString str_lan, str_stream, str_user;
		CString strXml;
		strXml = _T("<IPC_INFO>");
		str_lan.Format(_T("<LANConfig MacAddress=\"%s\"DHCP=\"%d\"IPAddress=\"%s\"Netmask=\"%s\"Gateway=\"%s\"DNS1=\"%s\"DNS2=\"%s\"/>"),
			pInfo->ipcInfo.info.szMac,
			pInfo->ipcInfo.info.dwDhcp,
			pInfo->ipcInfo.szIP, pInfo->ipcInfo.info.szNetmask, pInfo->ipcInfo.info.szGateway, pInfo->ipcInfo.info.szDns1, pInfo->ipcInfo.info.szDns2);
		strXml += str_lan;
		strXml += _T("</IPC_INFO>");
		USES_CONVERSION;
		lRet = AJ_NETSDK_IPC_ModifyIPCXML(pInfo->index, W2A(strXml));
	}*/
	return lRet;
}