#include "StdAfx.h"
#include "AjNetSdkDemo.h"
#include "AjNetSdkDemoDlg.h"
#include "PlayerWnd.h"
#include "NetSDKDevice.h"
#define PLAY_NUM 40

CNetSDKDevice::CNetSDKDevice(IPC_DEV_INFO* pInfo)
{
	ZeroMemory(&m_nDevInfo,sizeof(DEVINFO_NETSDK));
	m_szDevIP = pInfo->szIP;
	m_szSn = pInfo->szDevSn;
	m_szGroup = pInfo->szGroup;
	m_szProtocol = 0;
	m_szLikeName = pInfo->szName;
	_tcscpy_s(m_nDevInfo.szModel,pInfo->info.szModel);
	_tcscpy_s(m_nDevInfo.szMac,pInfo->info.szMac);
	_tcscpy_s(m_nDevInfo.szGateway,pInfo->info.szGateway);
	_tcscpy_s(m_nDevInfo.szNetmask,pInfo->info.szNetmask);
	_tcscpy_s(m_nDevInfo.szDns1,pInfo->info.szDns1);
	_tcscpy_s(m_nDevInfo.szDns2,pInfo->info.szDns2);
	_tcscpy_s(m_nDevInfo.szAccount,pInfo->info.szAccount);
	_tcscpy_s(m_nDevInfo.szCloudID,pInfo->info.szCloudID);
	_tcscpy_s(m_nDevInfo.szPwd,pInfo->info.szPwd);
	m_szCloudID = pInfo->info.szCloudID;
	m_nDevInfo.dwVideoPort = pInfo->info.dwVideoPort;
	m_nDevInfo.dwHttpPort = pInfo->info.dwHttpPort;
	m_nDevInfo.dwPtzPort = pInfo->info.dwPtzPort;
	m_nDevInfo.dwDhcp = pInfo->info.dwDhcp;
	m_lUserID = 0;
	m_lRealHandle_main = 0;
	m_lRealHandle_sub = 0;
	m_lStreamPlayerID = 0;
	m_pStreamParam_main = new STREAM_AV_PARAM;
	m_pStreamParam_sub = new STREAM_AV_PARAM;
	ZeroMemory(m_pStreamParam_main, sizeof(STREAM_AV_PARAM));
	ZeroMemory(m_pStreamParam_sub, sizeof(STREAM_AV_PARAM));
	m_iVoiceState = 0;
}


CNetSDKDevice::~CNetSDKDevice(void)
{
	SAFE_DELETE(m_pStreamParam_main);
	SAFE_DELETE(m_pStreamParam_sub);
}

long CNetSDKDevice::LoginDevice()
{
	if (m_bOnLine && m_lUserID > 0)
		return m_lUserID;
	long lUserID = -1;
	USES_CONVERSION;
	if (m_lUserID <= 0)
	{
		CString strUserName = m_nDevInfo.szAccount;
		CString strPassword = m_nDevInfo.szPwd;
		int nPtzPort = m_nDevInfo.dwPtzPort;
		CString strUrl = m_szDevIP;
		lUserID = AJ_NETSDK_IPC_Login(W2A(strUrl), nPtzPort, W2A(strUserName), W2A(strPassword), NULL);
		if (lUserID > 0)
			m_lUserID = lUserID;
	}
	return lUserID;
}

long CNetSDKDevice::LogoutDevice()
{
	LONG lUserID = 0;
	lUserID = m_lUserID;
	StopAudio();
	StopTalk();
	StopRealPlay();
	AJ_NETSDK_IPC_Logout(lUserID);
	m_lUserID = 0;
	m_bOnLine = FALSE;
	return 0;
}

long CNetSDKDevice::Disconnection()
{
	if (m_bOnLine)
	{
		m_iWillPlayIndex = m_iPlayWndIndex;
		StopAudio();
		StopTalk();
		StopRecord();
		StopRealPlay();
		m_bOnLine = FALSE;
		ReflashTreeImage();
	}
	return 0;
}

long CNetSDKDevice::OpenStream(int isSub)
{
	USES_CONVERSION;
	LONG lRealHandle = 0;
	if (isSub < 0 || isSub >1)
		return 0;
	if (m_bOnLine)
	{
		LONG lUserID = m_lUserID;
		if (lUserID > 0)
		{
			CString strUrl;
			strUrl.Format(_T("%s"), m_szDevIP);
			CString strUser = m_nDevInfo.szAccount;
			CString strPwd = m_nDevInfo.szPwd;
			try
			{
				lRealHandle = AJ_RTSP_CLINET_LIB_RealPlay(isSub, W2A(strUrl), W2A(strUser), W2A(strPwd), 1, m_nDevInfo.dwVideoPort,
					TiRealDataCallBackFunc, (void *)this);
			}
			catch (...)
			{
				lRealHandle = 0;
				return 0;
			}

			if (isSub == 0)
				m_lRealHandle_main = lRealHandle;
			else if (isSub == 1)
				m_lRealHandle_sub = lRealHandle;
		}
	} 
	return lRealHandle;
}

long CNetSDKDevice::CloseStream(int isSub)
{
	LONG lRealHandle = 0;
	if (isSub == 0)
	{
		lRealHandle = m_lRealHandle_main;
		m_lRealHandle_main = 0;
		ZeroMemory(m_pStreamParam_main, sizeof(STREAM_AV_PARAM));
	}
	else if (isSub == 1)
	{
		lRealHandle = m_lRealHandle_sub;
		m_lRealHandle_sub = 0;
		ZeroMemory(m_pStreamParam_sub, sizeof(STREAM_AV_PARAM));
	}
	if (lRealHandle > 0)
	{
		//int iRet = AJ_NETSDK_IPC_StopRealPlay(lRealHandle);
		AJ_RTSP_CLINET_LIB_StopRealPlay(lRealHandle);
	}
		
	return 0;
}

long CNetSDKDevice::RealPlay(int iWndIndex, int isSub)
{
	if (iWndIndex >= 0 || iWndIndex < MAX_CHANNEL || isSub == 0 || isSub == 1)
	{
		LONG lUserID = m_lUserID;
		if (m_bOnLine && lUserID > 0)
		{
			STREAM_AV_PARAM *pParam = NULL;
			CPlayerWnd* pWnd = NULL;
			LONG lReaderID = 0;
			LONG lRealHandle = 0;
			if (m_iPlayStream == isSub && m_iPlayWndIndex == iWndIndex)
				return -1;
			if (m_iPlayWndIndex >= 0)
				StopRealPlay();
			lRealHandle = isSub == 0 ? m_lRealHandle_main : m_lRealHandle_sub;
			if (lRealHandle <= 0)
			{
				lRealHandle = OpenStream(isSub);
				if (lRealHandle <= 0)
					return -1;
			}
			pParam = isSub == 1 ? m_pStreamParam_sub : m_pStreamParam_main;
			pWnd = ((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->GetPlayerWnd(iWndIndex);
			if (pWnd == NULL)
				return -1;
			lReaderID = pWnd->GetReaderID();
			if (lReaderID == 0)
				return -1;
			if (pParam->bHaveVideo)
			{
				long lRet = AJ_PLAYER_SetupDecoder(lReaderID, 1, (BYTE *)&(pParam->videoParam), sizeof(VIDEO_PARAM));
				//long lRet = IP_TPS_OpenStream(lReaderID, 1, (BYTE *)&(pParam->videoParam), sizeof(VIDEO_PARAM), 0, PLAY_NUM);
				if (lRet != 0)
					return -1;
			}
			if (pParam->bHaveAudio)
			{
				long lRet = AJ_PLAYER_SetupDecoder(lReaderID, 0, (BYTE *)&(pParam->audioParam), sizeof(AUDIO_PARAM));
			//	long lRet = IP_TPS_OpenStream(lReaderID, 1, (BYTE *)&pParam->audioParam, sizeof(AUDIO_PARAM), 1, PLAY_NUM);
			}
			AJ_PLAYER_SetFullFillStatus(lReaderID, 1);
		/*	int iRetPlay = IP_TPS_Play(lReaderID, pWnd->GetPlayWnd());
			IP_TPS_SetFullFillStatus(lReaderID, 1);*/
			m_hPlayWnd = pWnd->GetPlayWnd();
			m_lReaderID = lReaderID;
			m_iPlayStream = isSub;
			m_iPlayWndIndex = iWndIndex;
			pWnd->SetDevice(this);
			ReflashTreeImage();
			return 0;

		}
	}
	return -1;
}


long CNetSDKDevice::StopRealPlay()
{
	LONG lReaderID = 0;
	HWND hPlayWnd = NULL;
	int iViewStream = -1;
	int index = m_iPlayWndIndex;
	hPlayWnd = m_hPlayWnd;
	lReaderID = m_lReaderID;
	iViewStream = m_iPlayStream;
	StopAudio();
	m_lReaderID = -1;
	m_iPlayStream = -1;
	m_hPlayWnd = NULL;
	m_iPlayWndIndex = -1;
	
	StopTalk();
	if (lReaderID > 0)
	{
		AJ_PLAYER_CloseDecoder(lReaderID,1);
		AJ_PLAYER_CloseDecoder(lReaderID, 0);
		//IP_TPS_CloseStream(lReaderID);
	}
	StopRecord();
	CloseStream(iViewStream);
	m_lStreamPlayerID = 0;
	if (index >= 0 && index <= MAX_CHANNEL)
		((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->GetPlayerWnd(index)->SetDevice(NULL);
	ReflashTreeImage();
	return 0;
}

long CNetSDKDevice::StartRecord(int iRecordType,int iStreamType)
{
	if (m_iPlayStream < 0 || m_iRecordStream >= 0)
	{
		return -1;
	}
	long lRealHandle = 0;
	if (m_iPlayStream == 0)
	{
		lRealHandle = m_lRealHandle_main;
	}
	else
		lRealHandle = m_lRealHandle_sub;
	if (lRealHandle <= 0)
	{
		return -1;
	}
	CString strPath;
//	int iRet = AJ_NETSDK_IPC_StartRecord(lRealHandle, "c:\\", 1800, 100000);
	//if (iRet == 0)
	//{
	//	AJ_PLAYER_SetRecordStatus(m_lReaderID, 1);
	//	m_iRecordStream = iStreamType;
	//	m_iRecordType = 0;
	//}
	return -1;
}

long CNetSDKDevice::ResetRecord()
{
	return 0;
}

long CNetSDKDevice::StopRecord()
{
	if (m_iRecordStream < 0)
	{
		return 0;
	}
	long lRealHandle = 0;
	if (m_iRecordStream == 0)
	{
		lRealHandle = m_lRealHandle_main;
	}
	else
		lRealHandle = m_lRealHandle_sub;
	if (lRealHandle < 0)
	{
		m_iRecordStream = -1;
		m_iRecordType = -1;
		return 0;
	}
	AJ_PLAYER_SetRecordStatus(m_lReaderID, 0);
//	AJ_NETSDK_IPC_StopRecord(lRealHandle);
	m_iRecordStream = -1;
	m_iRecordType = -1;
	return 0;
}

long CNetSDKDevice::StartAudio()
{
	if (m_lReaderID > 0)
	{
		if (m_bAudioOpen == FALSE)
		{
			int iRet = AJ_PLAYER_SetAudioOn(m_lReaderID);
			if (iRet == 0)
			{
				m_bAudioOpen = TRUE;
				return 0;
			}
		}	
	}
	return -1;
}

long CNetSDKDevice::StopAudio()
{
	if (m_lReaderID > 0)
	{
		if (m_bAudioOpen)
		{
			AJ_PLAYER_SetAudioOff();
			m_bAudioOpen = FALSE;
		}
	}
	return 0;
}

long CNetSDKDevice::SnapShot(CString strPath)
{
	USES_CONVERSION;
	if (strPath.IsEmpty() == false)
	{
		if (m_lReaderID > 0)
		{
			return AJ_PLAYER_SnapShot(m_lReaderID, 1,W2A(strPath));
		}
		
	}
	return -1;
}

long CNetSDKDevice::SynchronizationTime()
{
	long lRet = -1;
	CTime time = CTime::GetCurrentTime();
	CString strTime = time.Format(_T("%Y%m%d %H:%M:%S"));
	TIME_ZONE_INFORMATION timeZoneInfo;
	GetTimeZoneInformation(&timeZoneInfo);
	int nZone = timeZoneInfo.Bias/-60;
	int timeZone = (12+nZone)*60;
	CString str;
	str.Format(_T("<REQUEST_PARAM Time=\"%s\" TimeZone=\"%d\"/>"),strTime,timeZone);
	USES_CONVERSION;
	if (m_lUserID > 0)
		lRet = AJ_NETSDK_IPC_SystemControl(m_lUserID,1005,0,W2A(str));
	return lRet;
}

long CNetSDKDevice::Reboot()
{
	if (m_lUserID > 0 && m_bOnLine)
	{
		return AJ_NETSDK_IPC_RebootDVR(m_lUserID);
	}
	return -1;
}

long CNetSDKDevice::StartVoiceCom()
{
	if (m_iVoiceState > 0)
		return -1;
	CString strErr;
	AUDIO_PARAM audioParam;
	ZeroMemory(&audioParam, sizeof(AUDIO_PARAM));
	if (m_pStreamParam_main->bHaveAudio)
	{
		memcpy(&audioParam, &m_pStreamParam_main->audioParam, sizeof(AUDIO_PARAM));
	}
	else if (m_pStreamParam_sub->bHaveAudio)
	{
		memcpy(&audioParam, &m_pStreamParam_sub->audioParam, sizeof(AUDIO_PARAM));
	}
	else
	{
		strErr.Format(_T("Խʧ,ȡƵʧ!"));
		AfxMessageBox(strErr);
		return -1;
	}
	LONG lRet = AJ_NETSDK_IPC_StartTalk(0,1, audioParam.samplerate, audioParam.bitrate, audioParam.channels);
	if (lRet == 0)
	{
		lRet = AJ_NETSDK_IPC_StartVoiceCom(m_lUserID, 0, 1, NULL, NULL);
		if (lRet == 0)
			m_iVoiceState = 1;
		else
			m_iVoiceState = 0;
		return 0;
	}
	else
		strErr.Format(_T("Խʧ,˷!"));
	AfxMessageBox(strErr);
	return 0;
}

long CNetSDKDevice::StartTalk()
{
	CString strErr;
	if (m_iVoiceState == 2)
	{		
		LONG lRet = AJ_NETSDK_IPC_AddTalk(m_lUserID);
		if (lRet == 0)
		{
			m_iVoiceState = 3;
			StartAudio();
			((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->PostMessage(UM_PLAYWND_SELECT);
			return 0;
		}	
	}
	else if (m_iVoiceState == 3)
		strErr.Format(_T("ԽѾ!"));
	if (m_iVoiceState == 2 || m_iVoiceState == 1)
	{
		AJ_NETSDK_IPC_StopVoiceCom(m_lUserID);
		AJ_NETSDK_IPC_StopTalk();
		m_iVoiceState = 0;
	}
	AfxMessageBox(strErr);
	return -1;
}

long CNetSDKDevice::StopTalk()
{
	if (m_iVoiceState == 0 || m_lUserID <= 0)
		return 0;
	else if (m_iVoiceState == 3)
	{
		AJ_NETSDK_IPC_RemoveTalk(m_lUserID);
		AJ_NETSDK_IPC_StopTalk();
	}
	AJ_NETSDK_IPC_StopVoiceCom(m_lUserID);
	m_iVoiceState = 0;
	((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->m_pManagePlayer->PostMessage(UM_PLAYWND_SELECT);
	return 0;
}

LONG __stdcall CNetSDKDevice::TiRealDataCallBackFunc(LONG lRealHandle,DWORD dwDataType,
	BYTE *pBuffer,DWORD dwBufSize,LPFRAME_EXTDATA  pExtData)
{
	CNetSDKDevice* pDevice = (CNetSDKDevice*)pExtData->pUserData;
	if (pDevice == NULL)
		return 0;
	LONG lReaderID = 0;
	HWND hPlayWnd = NULL;
	if (dwDataType == 2)
	{
		STREAM_AV_PARAM *pavParam = (STREAM_AV_PARAM *)pBuffer;
		if (lRealHandle == pDevice->m_lRealHandle_main)//
		{
			memcpy(pDevice->m_pStreamParam_main, pavParam, sizeof(STREAM_AV_PARAM));
			if (pDevice->m_iPlayStream == 0)
			{
				lReaderID = pDevice->m_lReaderID;
				hPlayWnd = pDevice->m_hPlayWnd;
			}
		}
		else if (lRealHandle == pDevice->m_lRealHandle_sub)
		{
			memcpy(pDevice->m_pStreamParam_sub, pavParam, sizeof(STREAM_AV_PARAM));
			if (pDevice->m_iPlayStream == 1)
			{
				lReaderID = pDevice->m_lReaderID;
				hPlayWnd = pDevice->m_hPlayWnd;
			}
		}
		if (hPlayWnd && lReaderID > 0)
		{
			if (pavParam->bHaveVideo)
			{
				long lRet = AJ_PLAYER_SetupDecoder(lReaderID, 1, (BYTE *)&(pavParam->videoParam), sizeof(VIDEO_PARAM));
				TRACE("CNetSDKDevice::TiRealDataCallBackFunc() AJ_PLAYER_SetupDecoder Video  lRet = %d \n",lRet);
				/*	long lRet = IP_TPS_OpenStream(lReaderID, 1, (BYTE *)&(pavParam->videoParam), sizeof(VIDEO_PARAM), 0, PLAY_NUM);
					if (lRet != 0)
					return -1;*/
			}
			if (pavParam->bHaveAudio)
			{
				long lRet = AJ_PLAYER_SetupDecoder(lReaderID, 0, (BYTE *)&(pavParam->audioParam), sizeof(AUDIO_PARAM));
				AJ_PLAYER_SetAudioOn(lReaderID);
				TRACE("CNetSDKDevice::TiRealDataCallBackFunc() AJ_PLAYER_SetupDecoder Audio  lRet = %d \n", lRet);
			//	long lRet = IP_TPS_OpenStream(lReaderID, 1, (BYTE *)&pavParam->audioParam, sizeof(AUDIO_PARAM), 1, PLAY_NUM);
			}
			AJ_PLAYER_SetFullFillStatus(lReaderID, 1);
			/*if (IsWindow(hPlayWnd))
			{
				IP_TPS_ClearBuffer(lReaderID);
				int iRetPlay = IP_TPS_Play(lReaderID, hPlayWnd);
				IP_TPS_SetFullFillStatus(lReaderID, 1);
			}	*/
		}
	}
	else if (dwDataType == 0)	//video
	{
		if (lRealHandle == pDevice->m_lRealHandle_main)
		{
			if (pDevice->m_iPlayStream == 0)
			{
				lReaderID = pDevice->m_lReaderID;
			}
		}
		else if (pDevice->m_lRealHandle_sub == lRealHandle)
		{
			if (pDevice->m_iPlayStream == 1)
			{
				lReaderID = pDevice->m_lReaderID;
			}
		}
   		if (lReaderID > 0)
		{
			MPEG4_VIDEO_FRAME_EXTRA  temp;
			temp.FrameType = pExtData->bIsKey;
			temp.TimeStamp = pExtData->timestamp;
			long lRet = AJ_PLAYER_DecodeFrame(lReaderID, 1, pBuffer, dwBufSize, (BYTE *)&(temp), sizeof(MPEG4_VIDEO_FRAME_EXTRA));	
//			long lInputErr = IP_TPS_InputVideoData(lReaderID, pBuffer, dwBufSize, pExtData->bIsKey, (DWORD)pExtData->timestamp);
			if (lRet != 0)
			{
				TRACE("CNetSDKDevice::TiRealDataCallBackFunc() AJ_PLAYER_DecodeFrame Video lRet : %d\n", lRet);
			}
			
		}
	}
	else if (dwDataType == 1)	//audio
	{
		if (lRealHandle == pDevice->m_lRealHandle_main)
		{
			if (pDevice->m_iPlayStream == 0)
			{
				lReaderID = pDevice->m_lReaderID;
			}
		}
		else if (pDevice->m_lRealHandle_sub == lRealHandle)
		{
			if (pDevice->m_iPlayStream == 1)
			{
				lReaderID = pDevice->m_lReaderID;
			}

		}
		if (lReaderID > 0)
		{
			G711_AUDIO_FRAME_EXTRA temp;
			temp.FrameType = pExtData->bIsKey;
			temp.TimeStamp = pExtData->timestamp;
			long lRet = AJ_PLAYER_DecodeFrame(lReaderID, 0, pBuffer, dwBufSize, (BYTE *)&(temp), sizeof(G711_AUDIO_FRAME_EXTRA));
			if (lRet != 0)
			{
				TRACE("CNetSDKDevice::TiRealDataCallBackFunc() AJ_PLAYER_DecodeFrame Audio lRet : %d\n", lRet);
			}
		//	long lInputErr = IP_TPS_InputAudioData(lReaderID, pBuffer, dwBufSize,(DWORD)pExtData->timestamp);
		}
	}
	return 0; 
}

long CNetSDKDevice::SetAudioEncode(AUDIO_ENCODE * pEncode)
{
	if (m_bOnLine == FALSE)
	{
		return -1;
	}
	CString strXml;
	CString strCode;
	if (pEncode->iEncodeType == 0)
	{
		strCode = L"G711";
	}
	else
		strCode = L"AAC";
	strXml.Format(L"<Encode Enable = \"%d\"	SampleRate = \"%d\" EncodeType = \"%s\"	BitRate = \"%d\"/>", pEncode->iEnable, pEncode->iSampleRate,
		strCode, pEncode->iBitRate);
	USES_CONVERSION;
	if (m_lUserID > 0)
	{
		return AJ_NETSDK_IPC_SetDVRConfig(m_lUserID, CMD_SET_MEDIA_AUDIO_ENCODE, 0, W2A(strXml), strXml.GetLength());
	}
	return -1;

}