// VoiceDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "AjNetSdkDemo.h"
#include "AjNetSdkDemoDlg.h"
#include "VoiceDlg.h"
#include "afxdialogex.h"
#include "NetSDKDevice.h"

// CVoiceDlg Ի

IMPLEMENT_DYNAMIC(CVoiceDlg, CDialogEx)

CVoiceDlg::CVoiceDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CVoiceDlg::IDD, pParent)
{
	m_pImageList = NULL;
	m_hDevice = NULL;
	m_bEnable = FALSE;
}

CVoiceDlg::~CVoiceDlg()
{
	SAFE_DELETE(m_pImageList);
}

void CVoiceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE_DEVICE, m_devTree);
}


BEGIN_MESSAGE_MAP(CVoiceDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BTN_ADD, &CVoiceDlg::OnBnClickedBtnAdd)
	ON_CBN_SELCHANGE(IDC_FORMAT_LIST, &CVoiceDlg::OnCbnSelchangeFormatList)
	ON_BN_CLICKED(IDC_BTN_ENABLE, &CVoiceDlg::OnBnClickedBtnEnable)
	ON_BN_CLICKED(IDC_BTN_FILE, &CVoiceDlg::OnBnClickedBtnFile)
END_MESSAGE_MAP()


// CVoiceDlg Ϣ


BOOL CVoiceDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  ڴӶĳʼ
	((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->InsertString(0, L"G711");
	((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->InsertString(1, L"AAC");
	((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->InsertString(2, L"PCM");
	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(0, L"8000");
	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(1, L"16000");
	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(2, L"32000");
	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(3, L"48000");
	((CComboBox*)GetDlgItem(IDC_CONNECT_LIST))->InsertString(0, L"UDP");
	((CComboBox*)GetDlgItem(IDC_CONNECT_LIST))->InsertString(1, L"TCP");
	((CComboBox*)GetDlgItem(IDC_CONNECT_LIST))->InsertString(2, L"Multicast");
	((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_CONNECT_LIST))->SetCurSel(1);
	m_devTree.ModifyStyle(0, TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS);
	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = NULL;
	tvInsert.hInsertAfter = NULL;
	tvInsert.item.mask = TVIF_TEXT;
	tvInsert.item.pszText = _T("Device List");
	m_hDevice = m_devTree.InsertItem(&tvInsert);
	m_devTree.Expand(m_hDevice, TVE_EXPAND);
	CBitmap *pBitmap;
	m_pImageList = new  CImageList();
	m_pImageList->Create(16, 16, ILC_MASK, 0, 16);
	pBitmap = new  CBitmap;
	pBitmap->LoadBitmap(IDB_BITMAP1);
	m_pImageList->Add(pBitmap, RGB(255, 0, 255));
	m_devTree.SetImageList(m_pImageList, TVSIL_NORMAL);
	m_devTree.SetItemImage(m_hDevice, 0, 0);
	//
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣:  OCX ҳӦ FALSE
}


void CVoiceDlg::OnBnClickedBtnAdd()
{
	// TODO:  ڴӿؼ֪ͨ
	CDeviceBase* pDevice = ((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->GetTreeSelectDevice();
	if (pDevice)
	{
		if (CheckSameDeviceInTree(pDevice) == 0)
		{
			HTREEITEM hDeviceItem = m_devTree.InsertItem(pDevice->m_szDevIP, m_hDevice, TVI_SORT);
			if (pDevice->GetDeviceIsOnline() == TRUE)
			{
				m_devTree.SetItemImage(hDeviceItem, 3, 3);
				AUDIO_ENCODE param;
				param.iEnable = 1;
				param.iEncodeType = ((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->GetCurSel();				
				if (param.iEncodeType == 0)
				{
					if (((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->GetCurSel() == 0)
					{
						param.iSampleRate = 8000;
					}
					else
					{
						param.iSampleRate = 16000;
					}
					param.iBitRate = 16;
				}
				else
				{
					param.iSampleRate = 16000;
					param.iBitRate = 16000;
				}
		//		pDevice->SetAudioEncode(&param);
			}		
			else
				m_devTree.SetItemImage(hDeviceItem, 2, 2);

			m_devTree.Expand(m_hDevice, TVE_EXPAND);
			m_devTree.SetItemData(hDeviceItem, (DWORD_PTR)pDevice);
		}
	}
}

int CVoiceDlg::CheckSameDeviceInTree(CDeviceBase *pCheckDevice)
{
	return TraverseTree(m_hDevice, pCheckDevice);
}

int CVoiceDlg::TraverseTree(HTREEITEM hTraverse, CDeviceBase *pCheckDevice)
{
	if (m_devTree.ItemHasChildren(hTraverse))
	{
		HTREEITEM hChildItem = m_devTree.GetChildItem(hTraverse);
		while (hChildItem != NULL)
		{
			int iResult = TraverseTree(hChildItem, pCheckDevice); //ݹӽڵ   
			if (iResult == 1)
				return iResult;
			hChildItem = m_devTree.GetNextItem(hChildItem, TVGN_NEXT);
		}
		return 0;
	}
	else
	{
		if (hTraverse == m_hDevice)
			return 0;
		CDeviceBase* pDevice = NULL;
		pDevice = (CDeviceBase*)m_devTree.GetItemData(hTraverse);
		if (pDevice)
		{
			if (pDevice == pCheckDevice)
			{
				return 1;
			}
			else
				return 0;
		}
		return 0;
	}
}


void CVoiceDlg::OnCbnSelchangeFormatList()
{
	// TODO:  ڴӿؼ֪ͨ
	//int iSel = ((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->GetCurSel();
	//((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->ResetContent();
	//if (iSel == 0)
	//{
	//	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(0, L"8000");
	//	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(1, L"16000");
	//}
	//else
	//	((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->InsertString(0, L"16000");
	//((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->SetCurSel(0);
}


void CVoiceDlg::OnBnClickedBtnEnable()
{
	// TODO:  ڴӿؼ֪ͨ
//	TraverseTreeOpenVice(m_hDevice, 0);
//	return;
	CString strErr;
	if (m_bEnable)
	{
		GetDlgItem(IDC_BTN_ENABLE)->SetWindowText(L"");
		TraverseTreeOpenVice(m_hDevice, 0);
		AJ_NETSDK_IPC_StopTalk();
		m_bEnable = FALSE;
	}
	else
	{ 	
		AUDIO_ENCODE param;
		param.iEnable = 1;
		param.iChannel = 1;
		param.iEncodeType = ((CComboBox*)GetDlgItem(IDC_FORMAT_LIST))->GetCurSel();
		if (param.iEncodeType == 1)
		{
			param.iChannel = 2;
		}
		int iSel = ((CComboBox*)GetDlgItem(IDC_SAMPLERATE_LIST))->GetCurSel();
		if (iSel == 0)
		{
			param.iSampleRate = 8000;
		}
		else if (iSel == 1)
		{
			param.iSampleRate = 16000;
		}
		else if (iSel == 2)
		{
			param.iSampleRate = 32000;
		}
		else if (iSel == 3)
		{
			param.iSampleRate = 48000;
		}
		int nConnectType = 0;
		nConnectType = ((CComboBox*)GetDlgItem(IDC_CONNECT_LIST))->GetCurSel();
		param.iBitRate = 16;
		CString strFile;
		GetDlgItem(IDC_FILE_PATH)->GetWindowText(strFile);
		if (strFile.IsEmpty())
		{
			long lRet = AJ_NETSDK_IPC_StartTalk(nConnectType, param.iEncodeType, param.iSampleRate, param.iBitRate, param.iChannel);
			if (lRet == 0)
			{
				if (AJ_NETSDK_IPC_StartAudioCapture(param.iSampleRate, param.iBitRate, param.iChannel, gMP3RealDataCallBack, this) == 0)
				{
					TraverseTreeOpenVice(m_hDevice, 1);
					m_bEnable = TRUE;
					GetDlgItem(IDC_BTN_ENABLE)->SetWindowText(L"ر");
				}
				else
					strErr.Format(_T("Խʧ,˷!"));
				return;
			}					
		}
		else
		{
			long lRet = AJ_NETSDK_IPC_StartTalk(nConnectType, param.iEncodeType, param.iSampleRate, param.iBitRate, param.iChannel);
			if (lRet == 0)
			{
				USES_CONVERSION;
				TraverseTreeOpenVice(m_hDevice, 1);
				m_bEnable = TRUE;
			//	AJ_NETSDK_IPC_StartAudioCapture(param.iSampleRate, param.iBitRate, param.iChannel, NULL, NULL);
//				MP3v1_SetDataCallback(gMP3RealDataCallBack, this);
//				MP3v1_SetAudioResampleFormat(param.iSampleRate, param.iChannel);
//				long iRet = MP3v1_LoadFile(W2A(strFile));
				GetDlgItem(IDC_BTN_ENABLE)->SetWindowText(L"ر");
				return;
			}
		//	else
		//		strErr.Format(_T("Խʧ,˷!"));
		}
		
		AfxMessageBox(strErr);
	}
}

int CVoiceDlg::TraverseTreeOpenVice(HTREEITEM hTraverse, int bOpen)
{
	if (m_devTree.ItemHasChildren(hTraverse))
	{
		HTREEITEM hChildItem = m_devTree.GetChildItem(hTraverse);
		while (hChildItem != NULL)
		{
			int iResult = TraverseTreeOpenVice(hChildItem, bOpen); //ݹӽڵ   
			if (iResult == 1)
				return iResult;
			hChildItem = m_devTree.GetNextItem(hChildItem, TVGN_NEXT);
		}
		return 0;
	}
	else
	{
		if (hTraverse == m_hDevice)
			return 0;
		CDeviceBase* pDevice = NULL;
		pDevice = (CDeviceBase*)m_devTree.GetItemData(hTraverse);
		if (pDevice)
		{
			if (pDevice->GetDeviceIsOnline())
			{
				CNetSDKDevice* pNetDevice = (CNetSDKDevice*)pDevice;
				if (pNetDevice->m_lUserID > 0)
				{
				//	long lRet = AJ_NETSDK_IPC_SearchOEMMp3File(pNetDevice->m_lUserID, 0);
				//	long lRet = AJ_NETSDK_IPC_UploadOEMMp3File(pNetDevice->m_lUserID, "C:\\Users\\Alvin.Chen\\Music\\Test.mp3");
					if (bOpen == 1)
					{
						long lRet = AJ_NETSDK_IPC_StartVoiceCom(pNetDevice->m_lUserID, 0, 1, NULL, NULL);
						if (lRet == 0)
						{
							pNetDevice->SetVoiceState(1);
						}
					}
					else
					{
						AJ_NETSDK_IPC_StopVoiceCom(pNetDevice->m_lUserID);
						pNetDevice->SetVoiceState(0);
					}
											
				}
				
			}
		}
		return 0;
	}
}

LONG  __stdcall CVoiceDlg::gMP3RealDataCallBack(BYTE *pBuffer, DWORD dwBufSize, void *pExtData)
{
	CVoiceDlg* pDlg = (CVoiceDlg*)pExtData;
	if (pDlg)
	{
		AJ_NETSDK_IPC_InputAudioData(AudioType_PCM,pBuffer, dwBufSize);
	}
	return 0;
}

void CVoiceDlg::OnBnClickedBtnFile()
{
	// TODO:  ڴӿؼ֪ͨ
	CFileDialog dlg(TRUE, _T("*.MP3"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("File(*.MP3;*.mp3;)|*.MP3;*.mp3;|"), CWnd::FromHandle(m_hWnd));///TRUEΪOPENԻFALSEΪSAVE ASԻ
	if (dlg.DoModal() == IDOK)
	{
		GetDlgItem(IDC_FILE_PATH)->SetWindowText(dlg.GetPathName());
	}
}
